// Alles was zum DDS gehrt steht hier drin
//
// Marcus Pool, DG9BFJ
//
// www.Marcus-Pool.de
//
// Revision: 0.1
// 
// 25.11.08

#include <main.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <util/delay.h> 

extern uint32_t freq_hz;	// speichert die Frequenz in Hz


///////////////////////////////////////////////////////////////////////////////
//
//	Umrechnung des Frequenzarrays in eine integer Zahl
//
///////////////////////////////////////////////////////////////////////////////
/*void freq_to_int(int /frequenz)
{
	char Buffer[20];

	// umrechnen vom array nach integerzahl 
	freq_hz = 	(frequenz[0] - '0') * 10000000 + (frequenz[1] - '0') * 1000000 + (frequenz[3] - '0') * 100000 + 
			(frequenz[4] - '0') * 10000L + (frequenz[5] - '0') * 1000 + (frequenz[7] - '0') * 100 +
			(frequenz[8] - '0') * 10 + (frequenz[9] - '0');
	sprintf(Buffer, "%10lu ", freq);
	lcd_gotoxy(0,3);
	lcd_puts(Buffer);
}
*/



///////////////////////////////////////////////////////////////////////////////
//
//	Programmieren des AD9854
//	Bitweise ausgeben der Daten. MSB zuerst
//
///////////////////////////////////////////////////////////////////////////////
void send_DDS_byte(uint8_t data)
{
	uint8_t datenlaenge = 8, i =0;
	for (i = 0; i < datenlaenge; i++)							// bitweise ausgeben der Daten
	{
		if (data & (0x80 >> i))				  					// 0x80 bei 8bit, 0x8000 bei 16bit, etc
		{
			SData = 1;											// Databit = 1
		}
		else
		{
			SData = 0;											// Databit = 0
		}
		SClk = 1; asm volatile ("nop\r\n nop\r\n nop\r\n"); SClk = 0;	// toggle clock Leitung
	}
}


///////////////////////////////////////////////////////////////////////////////
//
//	Konvertiere Frequenz fr AD9854
//
///////////////////////////////////////////////////////////////////////////////

void convertDDS(uint32_t data)
{
	uint8_t i;

#define DDS_SYS_CLK 200000000UL            		// DDS-Clk
#define DDS_MPL     0x01000000000000ULL   		// 2^48 => Shift 1<<48
union 	{	uint64_t reg; 
				uint8_t byte[8];
			} freq;         					// fr Byte-zugriff
	freq.reg = data * (DDS_MPL/DDS_SYS_CLK); 	// 32 x 32 Bit
	IOReset = 1; _delay_ms(1);IOReset = 0;		// Synchronisiere Data Input
	cli();										// deaktivieren der Interrupts
	send_DDS_byte(0x02);						// sende neue Frequenz in Register 2
	for (i = 0; i <= 5; i++)
	{
		send_DDS_byte(freq.byte[5-i]);
	}
	IOud = 1; asm volatile ("nop\r\n nop\r\n"); IOud = 0;	// Synchronisiere Data bergabe
	sei();										// aktivieren der Interrupts
}

///////////////////////////////////////////////////////////////////////////////
//
//	Initialisieren
//
///////////////////////////////////////////////////////////////////////////////
void Init_DDS(void)
{
	MReset = 0; IOud = 0; IOReset = 0; SData = 0; SClk = 0;		// alle Ausgnge = 0
	MReset = 1; _delay_ms(1);MReset = 0;						// Master Reset fr kurze Zeit = 1
	IOReset = 1; _delay_ms(1);IOReset = 0;						// Synchronisiere Data Input
	send_DDS_byte(0x07);										// schreibe in Control Register (CR)
	send_DDS_byte(0x10);										// sende 1. Control Register byte
	send_DDS_byte(0x20);										// sende 2. Control Register byte
	send_DDS_byte(0x00);										// sende 3. Control Register byte
	send_DDS_byte(0x40);										// sende 4. Control Register byte
	IOud = 1; _delay_ms(1); IOud = 0;							// Synchronisiere Data bergabe
	IOReset = 1; _delay_ms(1); IOReset = 0;						// Synchronisiere Data Input
	//schreibe Daten nochmal weil ab dem 4. byte das externe update aktiviert wurde
	send_DDS_byte(0x07);										// schreibe in Control Register (CR)
	send_DDS_byte(0x10);										// sende 1. Control Register byte
	send_DDS_byte(0x20);										// sende 2. Control Register byte
	send_DDS_byte(0x00);										// sende 3. Control Register byte
	send_DDS_byte(0x40);										// sende 4. Control Register byte
	IOud = 1; _delay_ms(1); IOud = 0;							// Synchronisiere Data bergabe
	//convertDDS(freq_hz);										// einstellen der gespeicherter Frequenz
}
