// Alles was zum DSP gehrt steht hier drin
//
// Marcus Pool, DG9BFJ
//
// www.Marcus-Pool.de
//
// Revision: 0.1
// 
// 02.06.09


#include <main.h>
#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h> 
#include <avr/eeprom.h>

extern uint8_t mode;

extern uint16_t leds;					// Zustand der LEDs

extern uint8_t  EE_AGC_A		EEMEM;	// AGC an (0) oder aus (1)
extern uint8_t  EE_AGC_B		EEMEM;	// AGC an (0) oder aus (1)
extern uint8_t  EE_Filter_A		EEMEM;	// Filter des DSP
extern uint8_t  EE_Filter_B		EEMEM;	// Filter des DSP

///////////////////////////////////////////////////////////////////////////////
//
//	Initialisieren
//
//	Filter 1 = SSB 2,7 KHz 		(U7)
//	Filter 2 = CW bei 700 Hz 	(U8)
//	Filter 3 = CW bei 800 HZ 	(U6)
//	Filter 4 = CW+ 				(U9)
//
///////////////////////////////////////////////////////////////////////////////
void Init_DSP(uint8_t mode_temp, uint8_t vfo)
{
//	if (mode_temp == mode)
//		return;
	Filter_1 = 1; Filter_2 = 1; Filter_3 = 1; Filter_4 = 1; // alle Filter zurck setzen

	if (mode_temp == 0x11)					// LSB, SSB (U )
	{ Filter_1 = 0; LSB_USB = 1;}
	else if (mode_temp == 0x12)				// LSB, CW 700 Hz (U )
	{ Filter_2 = 0; LSB_USB = 1;}
	else if (mode_temp == 0x13)				// LSB, CW 800 Hz (U )
	{ Filter_3 = 0; LSB_USB = 1;}
	else if (mode_temp == 0x14)				// LSB, CW plus (U )
	{ Filter_4 = 0; LSB_USB = 1;}
	else if (mode_temp == 0x21)				// USB, SSB
	{ Filter_1 = 0; LSB_USB = 0;}
	else if (mode_temp == 0x22)				// USB, CW 700 Hz
	{ Filter_2 = 0; LSB_USB = 0;}
	else if (mode_temp == 0x23)				// USB, CW 800 Hz
	{ Filter_3 = 0; LSB_USB = 0;}
	else if (mode_temp == 0x24)				// USB, CW plus
	{ Filter_4 = 0; LSB_USB = 0;}

	Filter_res = 0;	_delay_ms(1); Filter_res = 1;	// Reset zum neuladen der Koeffizienten
}
