// Definitionen fr AD9854 
#define Taster	7	// Port A
//#define LCD_RW	6 	// Port A
//#define LCD_RS	5 	// Port A
//#define LCD_E		4 	// Port A
//#define LCD_D7	3 	// Port A
//#define LCD_D6	2 	// Port A
//#define LCD_D5	1 	// Port A
//#define LCD_D4	0 	// Port A


//#define IOReset 7	// Port B
//#define IOud 	6	// Port B
#define PWM_LED	5	// Port B
//#define Filter4 4	// Port B
//#define Filter3	3	// Port B
//#define SCLK		2	// Port B
//#define Filter2	1	// Port B
//#define MRESET 	0	// Port B

#define Col1	7	// Port C
#define Col2	6	// Port C
#define Col3	5	// Port C
#define Col4	4	// Port C
#define Col5	3	// Port C
#define Row1	2	// Port C
#define Row2	1	// Port C
#define Row3	0	// Port C

#define Row4 	7	// Port D
#define Row5	6	// Port D
//#define SCLK	5	// Port D
//#define SDATA	4	// Port D
#define PTT_In	3	// Port D
#define INT		2	// Port D
#define ENC_A	1	// Port D
#define ENC_B	0	// Port D
#define PHASE_A     (PIND & 1<<PD0)
#define PHASE_B     (PIND & 1<<PD1)

#define ENC_A2	1	// Port F
#define ENC_B2	2	// Port F
#define Enc2_Tast 3	// Port F
#define PHASE_A2	(PINF & 1<<PF1)
#define PHASE_B2	(PINF & 1<<PF2)
#define Enc2_Taster	(PINF & 1<<PF3)


//#define TxD	1	// Port E
//#define RxD	0	// Port E

#define PCA9555 40

/* 19200 baud */
#define UART_BAUD_RATE      19200


//Definitionen
typedef unsigned char bytes;
struct test2 {
  bytes b0:1;
  bytes b1:1;
  bytes b2:1;
  bytes b3:1;
  bytes b4:1;
  bytes b5:1;
  bytes b6:1;
  bytes b7:1;
  bytes b8:1;
  bytes b9:1;
  bytes b10:1;
  bytes b11:1;
  bytes b12:1;
  bytes b13:1;
  bytes b14:1;
  bytes b15:1;
} __attribute__((__packed__));


#define BIT(r,n) (((volatile struct test2 *)&r)->b##n)

#define MReset			BIT(PORTB,0)
#define IOud			BIT(PORTB,6)
#define IOReset			BIT(PORTB,7)
#define SData			BIT(PORTD,4)
#define SClk			BIT(PORTD,5)
#define Filter_1	 	BIT(PORTG,0)
#define Filter_2		BIT(PORTB,1)
#define Filter_3		BIT(PORTB,3)
#define Filter_4		BIT(PORTB,4)
#define Filter_res		BIT(PORTE,6)
#define LSB_USB			BIT(PORTE,7)
#define AGC				BIT(PORTF,0)
#define PTT1			BIT(PORTE,2)
#define PTT2			BIT(PORTE,3)
#define PTT3			BIT(PORTE,4)
#define PTT4			BIT(PORTE,5)

#define Init			1
#define Front_LED		2
#define Rx				3
#define Tx				4


// Definitionen fr Frontplatten LEDs
#define PTT_LED_an		0x8000
#define PTT_LED_aus		0x7FFF
#define Lock_LED_an		0x0020
#define Lock_LED_aus	0xFFDF
#define RIT_an			0x1000
#define RIT_aus			0xEFFF
#define XIT_an			0x2000
#define XIT_aus			0xDFFF
#define AGC_LED_an		0x0200
#define AGC_LED_aus		0xFDFF
#define ATT_0dB_LED		0xFE7F
#define ATT_10dB_LED	0x0100
#define ATT_20dB_LED	0x0080
#define ATT_30dB_LED	0x0180

// Definitionen fr Tx_Relais
#define Rx_an			0x0200
#define Tx_an			0xFDFF
#define Ant3_aus		0x0100
#define Ant3_an			0xFEFF
#define Ant2_aus		0x0080
#define Ant2_an			0xFF7F
#define Ant1_aus		0x0040
#define Ant1_an			0xFFBF
#define Tx_6m			0x20
#define Tx_10m			0x10
#define Tx_12m			0x10
#define Tx_15m			0x10
#define Tx_17m			0x08
#define Tx_20m			0x08
#define Tx_40m			0x04
#define Tx_30m			0x04
#define Tx_80m			0x02
#define Tx_160m			0x01

// Definitionen fr Rx_Relais
#define ATT_30dB		0xC00
#define ATT_20dB		0x800
#define ATT_10dB		0x400
#define Rx_6m			0x200
#define Rx_10m			0x180
#define Rx_12m			0x80
#define Rx_15m			0x60
#define Rx_17m			0x20
#define Rx_20m			0x18
#define Rx_30m			0x08
#define Rx_40m			0x04
#define Rx_80m			0x03
#define Rx_160m			0x01
